pro gcm_panels,npp,delta,nxdim,nydim,xorig,yorig,xlen,ylen,cbaryoff,cbarydel

;------------------------------------------------------------------------
;
; procedure to set positions for multi-panel plots in gcm plot codes
;
; input parameters:
;
;   npp           integer            number of panels per page
;   delta         string             flag, =y to generate delta plot
;
; returned parameters:
;
;   nxdim         integer            window x-dimension in pixels
;   nydim         integer            window y-dimension in pixels
;   xorig         fltarr(npp)        x coordinates of plot origins
;   yorig         fltarr(npp)        y coordinates of plot origins
;   xlen          real               length of x axis
;   ylen          real               length of y axis
;   cbaryoff      real               y distance between plot origin
;                                     and colorbar origin
;   cbarydel      real               thickness of colorbar
;
;------------------------------------------------------------------------

;C  define viewport location for each panel
case 1 of
  (npp eq 1): begin
    nxdim=750
    nydim=750
    xorig=[0.15]
    yorig=[0.15]
    xlen=0.7
    ylen=0.7
    cbaryoff=0.05
    cbarydel=0.02
  end
  (npp eq 2): begin
    nxdim=750
    nydim=750
    xorig=[.2,.6]
    yorig=[.3,.3]
    xlen=0.3
    ylen=0.3
    cbaryoff=0.15
    cbarydel=0.02
  end
  (npp eq 3 and delta eq 'y'): begin
    nxdim=1000
    nydim=750
    xorig=[.045,.385,.725]
    yorig=[.20,.20,.20]
    xlen=0.27
    ylen=0.70
    cbaryoff=0.1
    cbarydel=0.01
  end
  (npp eq 4): begin
    nxdim=800
    nydim=800
    xorig=[0.1,0.6,0.1,0.6]
    yorig=[0.6,0.6,0.1,0.1]
    xlen=0.3
    ylen=0.3
    cbaryoff=0.03
    cbarydel=0.01
  end
  (npp eq 6): begin
    nxdim=800
    nydim=800
    xorig=[.15,.45,.75,.15,.45,.75]
    yorig=[.55,.55,.55,.10,.10,.10]
    xorig=[.15,.15,.45,.45,.75,.75]
    yorig=[.55,.10,.55,.10,.55,.10]
    xlen=0.2
    ylen=0.3
    cbaryoff=0.03
    cbarydel=0.02
  end
  (npp eq 8): begin
    nxdim=800
    nydim=800
    xorig=[.15,.35,.55,.75,.15,.35,.55,.75]
    yorig=[.55,.55,.55,.55,.1,.1,.1,.1]
    xlen=0.15
    ylen=0.3
    cbaryoff=0.055
    cbarydel=0.005
  end
endcase

end
