; gmao4_plot_calipso_parcel_maps.pro

@rd_gfs_nc3
@gcm_panels
@gcm_color_table

; MAIN program
;spawn,'ls -1 ../*wildfire.traj > trajfiles.dat '
setplot='Z'
set_plot,setplot
nruns=25
nruns=1
a=findgen(8)*(2*!pi/8.)
usersym,.3*cos(a),.3*sin(a),/fill

;
; add loop over mm for ploting 1-48 hour trajectories
;
close,1
for mm=1,48 do begin
ifilet=''
fdir='/usr61/Data/Model/Traject/INTEX/GFS/'
idir='/data/CEOS/GFS_traject/Traject/'
close,1
openr,1,'trajfiles_wildfire.fil'
readf,1,nruns

for nn=0L,nruns-1L do begin
    readf,1,ifilet
    close,12
    openr,12,idir+ifilet,/f77
    print,ifilet

label=strmid(ifilet,6,11)
print,label
;erase
;map_set,/continents
    nmax=600000l
    nrmax=181
    ncmax=361
    x=fltarr(ncmax)
    y=fltarr(nrmax)
;
    charexp='                                   '                         
    nthp=0L
    ukmo=' '
    nmc=' '
    ecmwf=' '
    restart=' '
    rfile='                                     '
    nrday=0
    dir='                                       '                             
    nfile=0
    wfile='                                               '
    istime=0l
    ictime=0l
    dtflow=0.                          
    dt=0.                              
    igw=' '                             
    stream=' '                          
    nstrm=0                           
    ds1=0.                             
    strm0=0.                           
    dstrm=0.                           
    pviso=' '
    npviso=0                          
    ds2=0.                             
    pv0=0.                             
    dpv=0.                             
    tiso=' '                            
    ntiso=0                           
    ds3=0.                             
    temp0=0.                           
    dtemp=0.
    space=' '
    dxs=0.                             
    dys=0.                             
    henry=' '
    dirh='                                     '
    hfile='                                     '
    range_fill=' '
    stlat=0.
    stlon=0.
    er2_range=' '
    nrings=0L
    npts=0L
    dial=' '
    dird='                                     '
    ndial=0l 
    dfile='                                     '
; new option curtain             tdf 4/19/2K5
    curtain=' '
    dirc='                                     '
    ncurt=0l 
    cfile='                                     '
; new option calipso             tdf 8/22/2K5
    calipso=' '
    er2=' '                             
    nleg=0                            
    xleg0=0.
    yleg0=0.
    xleg1=0.
    yleg1=0.
    dc8=' '
    dirdc8='/usr73/SOLVEII/DIAL_data/Datfiles/'
    ndc8=0L
    dc8file='dial_o3_20000309.diag.dc8'
    dtout=0.                           
    ofile='                                          '
    nr=0
    nc=0
    time=0.
    ntraj=0l
    char1='     '
    char2='     '
    char3='     '
    char4='     '
    char5='      '
    char6='       '
    char10='       '
    char11='        '
    char12='      '
    char13='       '
    char14='        '
    char15='        '
;
;  read input parameters for this experiment
;
    readu,12,charexp
;print,'charexp=',charexp
    readu,12,nthp       ; these are now eta surfaces
    thlevp=fltarr(nthp)
    readu,12,thlevp
;print,'thlevp=',thlevp
    readu,12,ukmo
    readu,12,nmc
    readu,12,ecmwf
    readu,12,restart
    readu,12,rfile
    readu,12,nrday
    readu,12,dir
    readu,12,nfile
    wfiles=strarr(nfile)
    for n=0,nfile-1 do begin
        readu,12,wfile
        wfiles(n)=strtrim(wfile)
        ;print,' wfile =',wfile
    endfor
    readu,12,istime
    readu,12,dtflow                          
    readu,12,dt                              
    readu,12,igw                             
    readu,12,stream                          
    readu,12,nstrm                           
    readu,12,ds1                             
    readu,12,strm0                           
    readu,12,dstrm                 
    readu,12,pviso                           
    readu,12,npviso                          
    readu,12,ds2                             
    readu,12,pv0                             
    readu,12,dpv                             
    readu,12,tiso                            
    readu,12,ntiso                           
    readu,12,ds3                             
    readu,12,temp0                           
    readu,12,dtemp                           
    readu,12,space                           
    readu,12,dxs                             
    readu,12,dys                             
; added new parameter  tdf
    readu,12,henry
    readu,12,dirh
    readu,12,hfile
; added new parameter
    readu,12,range_fill
    readu,12,stlat
    readu,12,stlon
    readu,12,er2_range
    readu,12,nrings
    readu,12,npts
    readu,12,dial
    readu,12,dird
    readu,12,ndial
    for n=1,ndial do begin 
        readu,12,dfile
        ;print , n, dfile 
    endfor 
; new option curtain             tdf 4/19/2K5
    readu,12,curtain
    readu,12,dirc
    ;print,' dirc =',dirc
    readu,12,ncurt
    for n=1,ncurt do begin 
        readu,12,cfile
        ;print , n, cfile 
    endfor 
; new option calipso             tdf 8/22/2K5
    readu,12,calipso
    readu,12,dirc
    readu,12,ncurt
    for n=1,ncurt do begin 
        readu,12,cfile
    endfor 
    readu,12,er2                             
    readu,12,nleg                            
    for n=1,nleg do begin                             
        readu,12,xleg0
        readu,12,yleg0
        readu,12,xleg1
        readu,12,yleg1
    endfor                                    
    readu,12,dc8
    readu,12,dirdc8
    readu,12,ndc8
    for n=1,ndc8 do begin
        readu,12,dc8file
;        ;print , n,dc8file
    endfor
    readu,12,dtout                           
    readu,12,ofile
    ;print,ofile
    print,'    Header read ok'

; Now read trajectory output

;    nfiles=mm*24l+1l    ; 5 days + 1 hour interval (for 24 hour output)
    nfiles=mm        ; (for 1 hour output)
;nfiles=49l
;***** Problem: sometimes no trajectories are output
; solve this by keeping track of output times  
;                                       tdf 5/10/2K5
times=fltarr(nfiles)

ipan=-1
; loop over files
    for n=0,nfiles-1 do begin

    if (EOF(12)) then goto, fend
        READU,12,istime,ictime,time,ntraj
        print,n,istime,ictime,time,ntraj
;
        stime=strcompress(string(istime),/remove_all)
        ctime=strcompress(string(ictime),/remove_all)
        mdate=strmid(stime,0,8)
;
        times(n) = time
;
        xn=fltarr(ntraj)
        yn=fltarr(ntraj)
; zn = eta level
        zn=fltarr(ntraj)
        pvn=fltarr(ntraj)
        pn=fltarr(ntraj)
; thn = potential temperature        tdf 11/08/2K4
        thn=fltarr(ntraj)
        qdfn=fltarr(ntraj)
; Montgomery S.F.                    tdf 11/08/2K4
        xmsfn=fltarr(ntraj)
; shn = specific humidity            tdf 11/08/2K4
        shn=fltarr(ntraj)
        t0n=fltarr(ntraj)
        agen=fltarr(ntraj)
        altn=fltarr(ntraj)

        readu,12,char1
        READU,12,xn
        readu,12,char2
        READU,12,yn
; pn  = pressure
        readu,12,char3
        READU,12,pn
        readu,12,char4
        READU,12,pvn
; thn = potential temperature        tdf 11/08/2K4
        readu,12,char5
        READU,12,thn
        readu,12,char10
        READU,12,qdfn
        readu,12,char11
; xmsfn = Montgomery S.F             tdf 11/08/2K4
        READU,12,xmsfn 
        readu,12,char12
; shn = specific humidity            tdf 11/08/2K4
        READU,12,shn 
;print,' read shn OK'
        readu,12,char13
        READU,12,t0n
        readu,12,char14
        READU,12,agen
        readu,12,char15
        readu,12,altn
!psym=3
index=where(xn ge 0. and xn le 360. and yn ge -90. and yn le 90.)
;oplot,xn(index),yn(index)
;plot,pn(index),yn(index)
;print,'xn',min(xn),max(xn)
;print,'yn',min(yn),max(yn)
;print,'zn',min(zn),max(zn)
;print,'pvn',min(pvn),max(pvn)
;print,'pn',min(pn),max(pn)
;print,'thn',min(thn),max(thn)
;print,'qdfn',min(qdfn),max(qdfn)
;print,'shn',min(shn),max(shn)
;print,'xmsfn',min(xmsfn),max(xmsfn)
;print,'t0n',min(t0n),max(t0n)
;print,'agen',min(agen),max(agen)
;goto, jumpall
aodn=0.*qdfn
; recall that the first output has the FULL number of trajectories
; initial conditions
        ;if ictime ge istime then begin
        if n eq 0 then begin
endtime=mm*24l ; for 24hr figures
endtime=mm     ; for 1hr figures
if endtime ge 99 then $
endtimelab=strmid(strcompress(string(endtime),/remove_all),0,3)
if endtime lt 99 then $
endtimelab=strmid(strcompress(string(endtime),/remove_all),0,4)
limit=[-90,-180,90,180]
p0lat=0.
p0lon=180.
if setplot eq 'Z' then begin
 device,set_resolution=[480,480],z_buffer=0
 ;window,xsize=720,ysize=576,retain=2
 nxpng=!d.x_size
 nypng=!d.y_size
 loadct,45,file='/home/bpierce/Tools/IDL_lib/color_ck.tbl'
 set_viewport,0,1,0,1
 !p.background=255.
 !p.color=254.
 erase
fl_png='wildfire_trajectories_'+stime+'.'+endtimelab+'hr.png'
endif
if setplot eq 'ps' then begin
          set_plot,'ps'
     xsize=nxdim/100.
     ysize=nydim/100.
     !psym=0
     device,/color,/landscape,bits=8,$
     filename='wildfire_trajectories_'+stime+'.'+endtimelab+'hr.ps'
     device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
     xsize=xsize,ysize=ysize
endif
if setplot eq 'eps' then begin
          set_plot,'ps'
     xsize=nxdim/100.
     ysize=nydim/100.
     !psym=0
     device,/color,/landscape,bits=8,$
     filename='wildfire_trajectories_'+stime+'.'+endtimelab+'hr.eps',/encapsulated
     device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
     xsize=xsize,ysize=ysize
endif
mcolor=253
icmm1=mcolor-1
icmm2=mcolor-2
!psym=0
set_viewport,.1,.9,.1,.9
;map_set,90,0,-90,/stereo,limit=[30,-180,80,180],$
;map_set,limit=[15,-135,50,-60],$
map_set,limit=[30,-15,60,60],$

/grid,latdel=10,londel=20,label=1,$
/continents,/us
;map_set,p0lat,p0lon,limit=limit,/continent,/noerase,/us

edir='/home/bpierce/CalNex/HMS/Amber_global/Files_1x1_DN/'
openr,11,edir+'modis_Dv7_bb_co_fuel_'+mdate+'_1x1.ALL',/f77
nlon=0
nlat=0
readu,11,nlon,nlat
lons=fltarr(nlon)
lats=fltarr(nlat)
bb_co_D=fltarr(nlon,nlat)
Dlength=fltarr(nlat)
readu,11,lons,lats
readu,11,bb_co_D
readu,11,Dlength
close,11
;Convert Day and Night units from 1/sec to 1/day
Dlength=Dlength>0.
for j=0,nlat-1 do begin
  bb_co_D(*,j) = bb_co_D(*,j)*Dlength(j)
endfor
bb_co=bb_co_D
; Make REGIONAL CO emissions plot
;

; bb_co (day+night) is in molec/day/cm2
; now convert into Tg/day
areacm2 = fltarr(nlon,nlat)
lat2d=fltarr(nlon,nlat)
lon2d=fltarr(nlon,nlat)
dlon=1.0*!pi/180.
dlat=1.0*!pi/180.
re=6.37e8  ;cm
for j=0,nlat-1 do areacm2(*,j)=re*re*dlon*dlat*cos(lats(j)*!pi/180.)
for j=0,nlat-1 do lat2d(*,j)=lats(j)
for i=0,nlon-1 do lon2d(i,*)=lons(i)
;print,max(bb_co)
bb_co = bb_co*areacm2/6.022e+23*(12.+16.)*1.e-12
;print,max(bb_co)

; initial locations
           x0=xn
           y0=yn
           p0=pn
           pv0=pvn
           th0=thn
e0=-9999.+0.*y0
for nt=0,ntraj-1 do begin
xindex=where(abs(x0(nt)-lons) le .5)
yindex=where(abs(y0(nt)-lats) le .5)
if xindex(0) ne -1 and yindex(0) ne -1 then e0(nt)=bb_co(xindex(0),yindex(0))
endfor
emiss_sort=sort(e0)
e0=e0(emiss_sort)
index=where(lat2d ge 30 and lat2d le 60 and lon2d ge -15 and lon2d le 60)
maxval=max(bb_co(index))
maxval=.01
maxval=0.0
level=max(bb_co(index))*findgen(31)/30.
y0=y0(emiss_sort)
x0=x0(emiss_sort)
        endif
xn=xn(emiss_sort)
yn=yn(emiss_sort)
neg=where(xn gt 180.,ineg)
if(ineg gt 0) then xn(neg)=xn(neg)-360.
neg=where(x0 gt 180.,ineg)
if(ineg gt 0) then x0(neg)=x0(neg)-360.

index=where(e0 ge maxval and y0 ge 30 and y0 le 60 and x0 ge -15. and x0 le 60.)
;index=where(y0 gt 50. and y0 lt 70. and x0 gt 180. and x0 lt 330. and e0 gt 0.)
    thiscol=1+icmm2*e0/maxval
    thiscol=thiscol<(1+icmm2)
    thiscol=thiscol<(icmm2)
       plots,xn(index),yn(index),psym=3,color=thiscol(index)
jumpall:
     endfor  ; end of loop over files
;goto, fend
if time ge 99 then $
timelab=strmid(strcompress(string(time),/remove_all),0,3)
if time lt 99 then $
timelab=strmid(strcompress(string(time),/remove_all),0,4)
;map_set,90,0,-90,/stereo,limit=[30,-180,80,180],$
map_set,limit=[30,-15,60,60],$
/grid,latdel=10,londel=20,label=1,$
/continents,/us,/noeras, $
;map_set,p0lat,p0lon,limit=limit,/continent,/noerase,/us,$
       title=timelab+'hr Wildfire Trajectories !CInitialized '+stime+' valid '+ctime
maxval=max(bb_co)*0.1
maxval=0.01
for i=0L,nlon-1L do begin
  lon0=lons(i)
  for j=0l,nlat-1L do begin
    lat0=lats(j)
    val0=bb_co(i,j)
    xbox=[lon0-.5,lon0+.5,lon0+.5,lon0-.5,lon0-.5]
    ybox=[lat0-.5,lat0-.5,lat0+.5,lat0+.5,lat0-.5]
    thiscol=1+icmm2*val0/maxval
    thiscol=thiscol<(1+icmm2)
    thiscol=thiscol<(icmm2)
    if val0 gt 0 then polyfill,xbox,ybox,color=thiscol
  endfor
endfor
if time ge 99 then $
timelab=strmid(strcompress(string(time),/remove_all),0,3)
if time lt 99 then $
timelab=strmid(strcompress(string(time),/remove_all),0,4)
;map_set,90,0,-90,/stereo,limit=[30,-180,80,180],$
map_set,limit=[30,-15,60,60],$
/grid,latdel=10,londel=20,label=1,$
/continents,/us,/noeras, $
;map_set,p0lat,p0lon,limit=limit,/continent,/noerase,/us,$
title=timelab+'hr Wildfire Trajectories !CInitialized '+stime+' valid '+ctime
map_continents,/countries,/us
!type=2^2+2^3
xmn=.3   ; lower-left
xmx=.7   ; lower-right
ymn=.1   ; the third element of set_viewport
ymx=.98   ; the fourth element of set_viewport
cbaryoff=.015 ; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
;icmm1=255. ; icolmax-1, where icolmax is (number of colors) - 1
color_title='Tg/day'
color_bar_png_white,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,color_title

if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 if index(0) eq -1 then goto,skippng3
 tvlct,r,g,b,/get
 png_dir='./PNG_images/'
 write_png,png_dir+fl_png,image_byt,r,g,b
 skippng3:
endif
fend:
endfor       ; end of loop over runs
endfor       ; end of loop over mm
end


