c This code takes Binary files and creates *.nc
c files on the GFS Pressure levels
c Based on GMAO_eta_v3.f
c                             rbp 02/07/2K6
c
c include file for netCDF functions
c
      include "netcdf.inc"
c
c  .. met field parameters:
      parameter (nc=720,nr=361,nl=26)
      integer istart(3) , icount(3)
      integer istart2(2), icount2(2),spacedims(3),vdims3d(3)
c
      data istart/1,1,1/
      data icount/nc,nr,nl/
      data istart2/1,1/
      data icount2/nc,nr/
c
c 3D fields from netcdf file
      COMMON/all3d/ pdash(nc,nr,nl),thl(nc,nr,nl),
     +        tl(nc,nr,nl),     ql(nc,nr,nl),
     +        ul(nc,nr,nl),     vl(nc,nr,nl),
c height                                        tdf 9/9/2K5
     +        hgtl(nc,nr,nl),
c omega
     +        pdot(nc,nr,nl),  delp(nc,nr,nl),
     +        psfc(nc,nr),apcp(nc,nr),zsfc(nc,nr),
     +        ubl(nc,nr),vbl(nc,nr),qbl(nc,nr),land(nc,nr),
     +        zpbl(nc,nr),clw(nc,nr),ptrp(nc,nr),
     +        alon(nc), alat(nr), eta(nl)
ctdf
c local hybrid arrays
       real dthdp(nc,nr,nl),qdf(nc,nr,nl),pv(nc,nr,nl)
       real qsfc(nc,nr),    qdfsfc(nc,nr),pvsfc(nc,nr)
       real usfc(nc,nr),    vsfc(nc,nr)
ctdf
c local temporary arrays for swapping longitudes
       real temp1d(nc), temp2d(nc,nr), temp3d(nc,nr,nl)
ctdf
ctdf  add in Montgomery stream function 
       real msf(nc,nr,nl)
ctdf
      character name*20
ctdf
   
      character ifile*120
C INITIALIZE CONSTANTS
      PI2 = 6.2831853071796
      DTR=PI2/360.
      RADEA=6.37E6

c Open GFS_press.fil
      close(10)
      open(10,file='/home/bpierce/Arvani/'//
     +'GFS_datfiles.fil',
     +     status='old',form='formatted')
      read(10,*)nfile
      print *,nfile

      do n=1,nfile
         read(10,*)ifile

        leni=0
        do m=1,119
          if(ifile(m:m+1).ne.' ')leni=leni+1
        enddo
        print *,' leni =',leni
ctdf
ctdf replace netcdf with binary read routine
ctdf  call read_hybrid(ifile(1:leni)//'nmhc.nc')
ctdf
        call read_gfs_pres(ifile(1:leni)//'dat')
ctdf
        print *,' returned from read_gfs_pres OK'

        call flush(6)
ctdf
        do l=1,nl
          pold=0.
          do i=1,nc
          do j=1,nr
crbp fill pdash with uniform GFS pressure levels
            pdash(i,j,l) = eta(l)
            if(l.lt.nl)
     &      delp(i,j,l)=.5*(eta(l)-pold)+.5*(eta(l+1)-eta(l))
            if(l.eq.nl)
     &      delp(i,j,l)=.5*(eta(l)-pold)
ctdf and convert omega to mbar /sec
            pdot(i,j,l) = 0.01 * pdot(i,j,l)
ctdf add in theta array - recall that pdash is in mbar   
            thl(i,j,l) = tl(i,j,l)*(1000./pdash(i,j,l))**.286
ctdf
          enddo
          enddo
          pold=eta(l)
        enddo
        print *,'pdash(1,90,k)',(pdash(1,90,k),k=1,nl)
        print *,'pdot(1,90,k)',(pdot(1,90,k),k=1,nl)
        print *,'tl(1,90,k)',(tl(1,90,k),k=1,nl)
ctdf
        call flush(6)
        close(1)
c
C COMPUTE ABSOLUTE VORTICITY  on the eta surface
c Make sure dimensions are consistent in COMPVORT  tdf 8/23/2K5
c
      CALL COMPVORT(UL,VL,PV,NC,NR,NL)
      print *,' returned from COMPVORT OK'
      call flush(6)

ctdf Geopotential height is read in. Don't need to call
ctdf "geopotential". Instead, diagnose MSF from GL.
      call get_msf(NC,NR,NL,TL,HGTL,MSF)
      print *,' returned from get_msf OK '

      call flush(6)

c COMPUTE VERTICAL DERIVATIVE OF THETA
      DO 900 I=1,NC
      DO 900 J=1,NR
      DO 900 K=1,NL
         LP1=K+1
         LM1=K-1
         IF(K.EQ.1)LM1=1
         IF(K.EQ.NL)LP1=NL
         DTHDP(I,J,K)=(THL(I,J,LP1)-THL(I,J,LM1))/
     +                (PDASH(I,J,LP1)-PDASH(I,J,LM1))
900   CONTINUE

c calculation of QDF deformation diagnostic
      DO 1000 LAT = 1,NR
      JP1=LAT-1
      JM1=LAT+1
      JP2=LAT-2
      JM2=LAT+2
      IF(LAT.EQ.1)THEN
      JP1=1
      JP2=1
      ENDIF
      IF(LAT.EQ.NR)THEN
      JM1=nr
      JM2=nr
      ENDIF
      IF(LAT.EQ.NR-1)JM2=NR
      IF(LAT.EQ.2)JP2=1
      DY1=RADEA*(ALAT(JP1)-ALAT(JM1))*DTR
      DY2=RADEA*(ALAT(JP2)-ALAT(JM2))*DTR
      DX1=RADEA*COS(ALAT(LAT)*DTR)*PI2/(.5*NC)
      DX2=RADEA*COS(ALAT(LAT)*DTR)*PI2/(.25*NC)

      DO 1000 I=1,NC
      IP1=I+1
      IM1=I-1
      IP2=I+2
      IM2=I-2
      IF(I.EQ.1)THEN
      IM1=NC
      IM2=NC-1
      ENDIF
      IF(I.EQ.NC)THEN
      IP1=1
      IP2=2
      ENDIF
      IF(I.EQ.2)IM2=NC
      IF(I.EQ.NC-1)IP2=1

      DO 1500 K=1,NL
      LM1=K-1
      LP1=K+1
      IF(K.EQ.1)LM1=1
      IF(K.EQ.NL)LP1=NL
      QDF(I,LAT,K) = 1.e15
      DUDP=(UL(I,LAT,LP1)-UL(I,LAT,LM1))/
     &     (PDASH(I,LAT,LP1)-PDASH(I,LAT,LM1))
      DVDP=(VL(I,LAT,LP1)-VL(I,LAT,LM1))/
     &     (PDASH(I,LAT,LP1)-PDASH(I,LAT,LM1))
      DTHDX = (4./3.)*(THL(IP1,LAT,K)-THL(IM1,LAT,K))/DX1 -
     &        (1./3.)*(THL(IP2,LAT,K)-THL(IM2,LAT,K))/DX2
      IF(LAT.LE.2.OR.LAT.GE.NR-1)THEN
         DTHDY = (THL(I,JP1,K)-THL(I,JM1,K))/DY1
      ELSE
         DTHDY = (4./3.)*(THL(I,JP1,K)-THL(I,JM1,K))/DY1 -
     &           (1./3.)*(THL(I,JP2,K)-THL(I,JM2,K))/DY2
      ENDIF

c normalized by RADEA. The signed sqrt of Q is taken.
      arg1 = (UL(IP1,LAT,K)-UL(IM1,LAT,K))/DX1
     +     - VL(I,LAT,K)*TAN(ALAT(LAT)*DTR)/RADEA
      arg2 = (VL(IP1,LAT,K)-VL(IM1,LAT,K))/DX1
     +     + UL(I,LAT,K)*TAN(ALAT(LAT)*DTR)/RADEA
      DVDY = (VL(I,JP1,K)-VL(I,JM1,K))/DY1
      DUDY = (UL(I,JP1,K)-UL(I,JM1,K))/DY1
      if ((abs(arg1) .gt. 1.e12) .or. (abs(arg2) .gt. 1.e12)) then
         QDF(I,LAT,K) = 1.e15
      else
         qtemp=(0.5*(arg1*arg1+DVDY*DVDY)+arg2*DUDY)*RADEA*RADEA
ctdf Signed square-root 
         if (qtemp .ge. 0.0) QDF(I,LAT,K) = sqrt(qtemp)
         if (qtemp .lt. 0.0) QDF(I,LAT,K) = -sqrt(-qtemp)
      endif
c end calculation of QDF deformation diagnostic

C COMPUTE ISENTROPIC POTENTIAL VORTICITY ON eta SURFACE
      IF(DTHDP(I,LAT,K).GE.0.) THEN
ctdf Quality Control on super-adiabatic lapse rates
        PV(I,LAT,K) = 1.E15
      ELSE
ctdf Adjust absolute vorticity
      PV(I,LAT,K)=PV(I,LAT,K)-(DUDP*DTHDY-DVDP*DTHDX)/DTHDP(I,LAT,K)
      PV(I,LAT,K)=-9.8*DTHDP(I,LAT,K)*PV(I,LAT,K)
      ENDIF

1500  CONTINUE    ! End of loop over K
c
c calculate surface PV, QDF, and Q
c
          pvsfc(i,lat)  = pv(i,lat,nl)
          qdfsfc(i,lat) = qdf(i,lat,nl)
c specific humidity
          qsfc(i,lat)   = ql(i,lat,nl)

ctdf No longer interpolate fields to isentropic levels
ctdf Instead retain fields on GFS pressure levels
ctdf
      DO 2000 M = 1, NL
c check for bad pv
      if(abs(PV(I,LAT,M)).gt.1000.) then
c         print *,pv(i,lat,m),dthdp(i,lat,k)
        PV(I,LAT,M)=1.e15
      endif
2000  CONTINUE
1000  CONTINUE    ! End of loop over I,J

c average QDF for polar rows
ctdf      do 3000 M = 1, NTH
      do 3000 M = 1, NL
        xlst=0.0
        frst=0.0
        do I = 1, nc
          xlst = xlst + QDF(i,nr-1,m)/nc
          frst = frst + QDF(i,2,m)/nc
        end do
        do I = 1, nc
          QDF(i,nr,m) = xlst
          QDF(i,1,m) = frst
        end do
3000  continue

c pv is bad at the poles
      do i=1,nc
         do m = 1, nl
            pv(i,1,m)=1.e15
            pv(i,nr,m)=1.e15
         enddo
      enddo

cNB Convert psfc from Pa to mbar
      do i=1,nc
        do j=1,nr
           psfc(i,j)=psfc(i,j)/100.
         enddo
      enddo

c Create netCDF dataset only if it doesn't exist
      ncid = nccre('/data/Met/GFS/Netcdf/'//
     &ifile(1:leni)//'nc3', NCCLOB, iret)
      print *,ncid,' opened netcdf file',ifile(1:leni)//'nc3'

c define dimensions
      londimid=ncddef(ncid, 'number_of_longitudes', nc, iret)
      latdimid=ncddef(ncid, 'number_of_latitudes', nr, iret)
      levdimid=ncddef(ncid, 'number_of_levels',    nl, iret)

      print *,' nc, nr, nl =',nc,nr,nl

c check dimensions
c     print *,' '
      print *,' DIMENSIONS                 LENGTH '
      call ncdinq(ncid, londimid, name, len, iret)
      print *,name,'=',ncid,len,iret

      call ncdinq(ncid, latdimid, name, len, iret)
      print *,name,'=',ncid,len,iret

      call ncdinq(ncid, levdimid, name, len, iret)
      print *,name,'=',ncid,len,iret

c Define variables
      lonsid = ncvdef(ncid, 'longitudes', NCFLOAT, 1, londimid, iret)
      print *,' lonsid defined OK',lonsid
      call flush(6)
      latsid = ncvdef(ncid, 'latitudes',  NCFLOAT, 1, latdimid, iret)
      print *,' latsid defined OK',latsid
      call flush(6)
ctdf      levsid = ncvdef(ncid, 'th_levels',  NCFLOAT, 1, levdimid, iret)
      levsid = ncvdef(ncid, 'eta_levels',  NCFLOAT, 1, levdimid, iret)
      print *,' levsid defined OK',levsid
      call flush(6)

      spacedims(1) = londimid
      spacedims(2) = latdimid
      spacedims(3) = levdimid
ctdf IPV
      idpv = ncvdef(ncid, 'ipv',    NCFLOAT, 3, spacedims, iret)
ctdf pressure
      idp  = ncvdef(ncid, 'press',  NCFLOAT, 3, spacedims, iret)
ctdf Montgomery Stream function
      idm  = ncvdef(ncid, 'msf',    NCFLOAT, 3, spacedims, iret)
ctdf Zonal wind
      idu  = ncvdef(ncid, 'u_wind', NCFLOAT, 3, spacedims, iret)
ctdf Meridional wind
      idv  = ncvdef(ncid, 'v_wind', NCFLOAT, 3, spacedims, iret)
ctdf geopotential height
      idg  = ncvdef(ncid, 'height', NCFLOAT, 3, spacedims, iret)
ctdf Add theta
      idth = ncvdef(ncid, 'theta',  NCFLOAT, 3, spacedims, iret)
ctdf specific humidity
      idsh = ncvdef(ncid, 'sp_hum', NCFLOAT, 3, spacedims, iret)
ctdf QDF
      idqd = ncvdef(ncid, 'qdf',    NCFLOAT, 3, spacedims, iret)
ctdf p-dot            tdf 10/12/2K4
      idep = ncvdef(ncid, 'p_dot',  NCFLOAT, 3, spacedims, iret)
ctdf thdot            tdf 10/12/2K4
ctdf      idq  = ncvdef(ncid, 'th_dot', NCFLOAT, 3, spacedims, iret)
ctdf psfc
      ips =  ncvdef(ncid, 'psfc',   NCFLOAT, 2, spacedims, iret)
crbp ubl
      iubl =  ncvdef(ncid, 'ubl',   NCFLOAT, 2, spacedims, iret)
crbp vbl
      ivbl =  ncvdef(ncid, 'vbl',   NCFLOAT, 2, spacedims, iret)
crbp qbl
      iqbl =  ncvdef(ncid, 'qbl',   NCFLOAT, 2, spacedims, iret)
crbp land
      iland =  ncvdef(ncid, 'land',   NCFLOAT, 2, spacedims, iret)
crbp zpbl
      izpbl =  ncvdef(ncid, 'zpbl',   NCFLOAT, 2, spacedims, iret)
crbp clw
      iclw =  ncvdef(ncid, 'clw',   NCFLOAT, 2, spacedims, iret)
crbp ptrp
      iptrp =  ncvdef(ncid, 'ptrp',   NCFLOAT, 2, spacedims, iret)
crbp apcp
      iapcp =  ncvdef(ncid, 'apcp',   NCFLOAT, 2, spacedims, iret)



c
      print *,' idep defined OK',idep
      call flush(6)

c Leave define mode and enter data mode
      call ncendf(ncid, iret)

c Write arrays (lons,rlats,th,pv,p,msf,u,v,q,qdf)
ctdf      WRITE(6,*)' WRITING ISENTROPIC OUTPUT ......'
      WRITE(6,*)' WRITING ETA level OUTPUT ......'
      call ncvpt (ncid, lonsid, 1, nc , alon , iret)
      call ncvpt (ncid, latsid, 1, nr , alat , iret)

ctdf Replace thlev with etalev
ctdf      call ncvpt (ncid, levsid, 1, nth , thlev, iret)
      call ncvpt (ncid, levsid, 1, nl , eta, iret)
      print *,' eta output', eta
      print *,' eta output OK',levsid
      call flush(6)

      call ncvpt (ncid, idpv, istart, icount,  PV, iret)
      call ncvpt (ncid, idp , istart, icount, PDASH, iret)
ctdf Add Montgomery stream function here
      call ncvpt (ncid, idm , istart, icount, MSF, iret)
      print *,' MSF output OK',idm
      call ncvpt (ncid, idu , istart, icount,   UL, iret)
      call ncvpt (ncid, idv , istart, icount,   VL, iret)
ctdf height                                  tdf 9/9/2K5
      call ncvpt (ncid, idg , istart, icount, HGTL, iret)
ctdf Add theta here
      call ncvpt (ncid, idth, istart, icount,  THL, iret)
ctdf specific humidity
      call ncvpt (ncid, idsh, istart, icount,   QL, iret)
ctdf QDF
      call ncvpt (ncid, idqd, istart, icount,  QDF, iret)
      print *,' qdf output OK',idqd
ctdf omega                           tdf 10/12/2K4
      call ncvpt (ncid, idep, istart, icount, PDOT, iret)
      print *,' p_dot output OK',idep
ctdf psfc                            tdf 7/28/2K5
      call ncvpt (ncid, ips, istart, icount2, PSFC, iret)
      print *,' psfc output OK',ips
crbp ubl
      call ncvpt (ncid, iubl, istart, icount2, ubl, iret)
      print *,' ubl output OK',iubl
crbp vbl
      call ncvpt (ncid, ivbl, istart, icount2, vbl, iret)
      print *,' vbl output OK',ivbl
crbp qbl
      call ncvpt (ncid, iqbl, istart, icount2, qbl, iret)
      print *,' qbl output OK',iqbl
crbp land
      call ncvpt (ncid, iland, istart, icount2, land, iret)
      print *,' land output OK',iland
crbp zpbl
      call ncvpt (ncid, izpbl, istart, icount2, zpbl, iret)
      print *,' zpbl output OK',izpbl
crbp clw
      call ncvpt (ncid, iclw, istart, icount2, clw, iret)
      print *,' clw output OK',iclw
crbp ptrp
      call ncvpt (ncid, iptrp, istart, icount2, ptrp, iret)
      print *,' ptrp output OK',iptrp
crbp apcp
      call ncvpt (ncid, iapcp, istart, icount2, apcp, iret)
      print *,' apcp output OK',iapcp

      call flush(6)

c close netCDF dataset
      call ncclos(ncid, iret)

6000    continue
      enddo
100   format(i2)
200   format(a60)
300   format(a40)

      end
c**************************************************************
      SUBROUTINE COMPVORT(UL,VL,IPV,nlg,nlat,nlv)
ctdf Compute absolute vorticity
ctdf
      dimension ul(nlg,nlat,nlv),vl(nlg,nlat,nlv),alat(nlat)
      REAL IPV(NLG,NLAT,NLV)

C  INITIALIZE CONSTANTS
      PI2 = 6.2831853071796
      DTR=PI2/360.
      RADEA=6.37E6
      OMEGA=7.292E-5
ctdf
      dlat = 180. / (nlat-1)
c initialize latitude/longitude arrays
      do j=1,nlat
         alat(j)=-90.+dlat*(j-1)
      enddo

C  COMPUTE ABSOLUTE VORTICITY ON PRESSURE SURFACE
      DO 200 LAT = 1,NLAT
      JP1=LAT-1
      JM1=LAT+1
      JP2=LAT-2
      JM2=LAT+2
      IF(LAT.EQ.1)THEN
      JP1=1
      JP2=1
      ENDIF
      IF(LAT.EQ.NLAT)THEN
      JM1=nlat
      JM2=nlat
      ENDIF
      IF(LAT.EQ.NLAT-1)JM2=NLAT
      IF(LAT.EQ.2)JP2=1
      DY1=RADEA*(ALAT(JP1)-ALAT(JM1))*DTR
      DY2=RADEA*(ALAT(JP2)-ALAT(JM2))*DTR
      DX1=RADEA*COS(ALAT(LAT)*DTR)*PI2/(.5*NLG)
      DX2=RADEA*COS(ALAT(LAT)*DTR)*PI2/(.25*NLG)
      DO 200 I=1,NLG
      IP1=I+1
      IM1=I-1
      IP2=I+2
      IM2=I-2
      IF(I.EQ.1)THEN
      IM1=NLG
      IM2=NLG-1
      ENDIF
      IF(I.EQ.NLG)THEN
      IP1=1
      IP2=2
      ENDIF
      IF(I.EQ.2)IM2=NLG
      IF(I.EQ.NLG-1)IP2=1

      DO 200 L=1,NLV
ctdf
      IPV(I,LAT,L)=1.E15
      if(VL(IP1,LAT,L).eq.1.e15.OR.VL(IM1,LAT,L).eq.1.e15.OR.
     &   UL(IP1,LAT,L).eq.1.e15.OR.UL(IM1,LAT,L).eq.1.e15)goto 200
      DVDX = (4./3.)*(VL(IP1,LAT,L)-VL(IM1,LAT,L))/DX1 -
     &        (1./3.)*(VL(IP2,LAT,L)-VL(IM2,LAT,L))/DX2
      IF(LAT.LE.2.OR.LAT.GE.NLAT-1)THEN
      DUDY = (UL(I,JP1,L)*COS(ALAT(JP1)*DTR)-
     &        UL(I,JM1,L)*COS(ALAT(JM1)*DTR))/DY1
      ELSE
      DUDY = (4./3.)*(UL(I,JP1,L)*COS(ALAT(JP1)*DTR)
     &               -UL(I,JM1,L)*COS(ALAT(JM1)*DTR))/DY1 -
     &        (1./3.)*(UL(I,JP2,L)*COS(ALAT(JP2)*DTR)
     &               -UL(I,JM2,L)*COS(ALAT(JM2)*DTR))/DY2
      ENDIF
      DUDY=DUDY/COS(ALAT(LAT)*DTR)
ctdf Absolute vorticity 
      IPV(I,LAT,L)=2.*OMEGA*SIN(ALAT(LAT)*DTR)+DVDX-DUDY
200   CONTINUE
      RETURN
      END


      subroutine read_geos4_eta(ifile)
ctdf
c  Simple driver to read in GEOS-4 data
ctdf
c  .. met field parameters:
      parameter (nc=360,nr=181,nl=26)
ctdf
c 3D fields from netcdf file
      common/all3d/ pdash(nc,nr,nl),thl(nc,nr,nl),
     +        tl(nc,nr,nl),     ql(nc,nr,nl),
     +        ul(nc,nr,nl),     vl(nc,nr,nl),
c height                                        tdf 9/9/2K5
     +        hgtl(nc,nr,nl),
c omega
     +        pdot(nc,nr,nl),  delp(nc,nr,nl),
     +        psfc(nc,nr),apcp(nc,nr),zsfc(nc,nr),
     +        ubl(nc,nr),vbl(nc,nr),qbl(nc,nr),land(nc,nr),
     +        zpbl(nc,nr),clw(nc,nr),ptrp(nc,nr),
     +        alon(nc), alat(nr), eta(nl)
c
      character *(*) ifile
c
      character name*20
      integer inc,inr,inl
c
      open (unit=30,file='/data/Met/GFS/Pres/'//
     &ifile,status='old',form='unformatted')
      read (30) inc,inr,inl
      read (30) alon,alat,eta
c pdot is in Pa/s and psfc is in Pa          tdf 7/29/2K5
      read (30) ul,vl,tl,ql,pdot,hgtl
      read (30) psfc
      return
      end
      subroutine read_gfs_pres(ifile)
ctdf
c  Simple driver to read in GFS pressure data
ctdf
c  .. met field parameters:
      parameter (nc=720,nr=361,nl=26)
ctdf
c 3D fields from netcdf file
      common/all3d/ pdash(nc,nr,nl),thl(nc,nr,nl),
     +        tl(nc,nr,nl),     ql(nc,nr,nl),
     +        ul(nc,nr,nl),     vl(nc,nr,nl),
c height                                        tdf 9/9/2K5
     +        hgtl(nc,nr,nl),
c omega
     +        pdot(nc,nr,nl),  delp(nc,nr,nl),
     +        psfc(nc,nr),apcp(nc,nr),zsfc(nc,nr),
     +        ubl(nc,nr),vbl(nc,nr),qbl(nc,nr),land(nc,nr),
     +        zpbl(nc,nr),clw(nc,nr),ptrp(nc,nr),
     +        alon(nc), alat(nr), eta(nl)
c
      real dummy3(nc,nr,nl)
      real dummy2(nc,nr)
      real dummy1(nr)
      character *(*) ifile
c
      character name*20
      integer inc,inr,inl
      integer hour,day,month,year
c
      open (unit=30,file='/data/Met/GFS/Pres/'//
     &ifile,status='old',form='unformatted')
      read (30) hour,day,month,year
      read (30) inc,inr,inl
      read (30) alon,alat,eta
c pdot is in Pa/s and psfc is in Pa          tdf 7/29/2K5
      read (30) ul,vl,pdot,tl,ql,hgtl
      read (30) apcp,zsfc,psfc
      read (30) ubl,vbl,qbl,land,zpbl,clw,ptrp
c
c swap latitude from NP->SP to SP->NP
c
      do ivar=1,10
      do i=1,nc
      do j=1,nr
      if(ivar.eq.1)dummy2(i,j)=psfc(i,j)
      if(ivar.eq.2)dummy2(i,j)=zsfc(i,j)
      if(ivar.eq.3)dummy2(i,j)=apcp(i,j)
      if(ivar.eq.4)dummy2(i,j)=ubl(i,j) 
      if(ivar.eq.5)dummy2(i,j)=vbl(i,j) 
      if(ivar.eq.6)dummy2(i,j)=qbl(i,j) 
      if(ivar.eq.7)dummy2(i,j)=land(i,j) 
      if(ivar.eq.8)dummy2(i,j)=zpbl(i,j) 
      if(ivar.eq.9)dummy2(i,j)=clw(i,j) 
      if(ivar.eq.10)dummy2(i,j)=ptrp(i,j)  
      do l=1,nl
      if(ivar.eq.1)dummy3(i,j,l)=ul(i,j,l)
      if(ivar.eq.2)dummy3(i,j,l)=vl(i,j,l)
      if(ivar.eq.3)dummy3(i,j,l)=pdot(i,j,l)
      if(ivar.eq.4)dummy3(i,j,l)=tl(i,j,l)
      if(ivar.eq.5)dummy3(i,j,l)=ql(i,j,l)
      if(ivar.eq.6)dummy3(i,j,l)=hgtl(i,j,l)
      enddo
      enddo
      enddo
      do i=1,nc
      do j=1,nr
      if(ivar.eq.1)psfc(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.2)zsfc(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.3)apcp(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.4)ubl(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.5)vbl(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.6)qbl(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.7)land(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.8)zpbl(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.9)clw(i,j)=dummy2(i,nr-j+1)
      if(ivar.eq.10)ptrp(i,j)=dummy2(i,nr-j+1)

      do l=1,nl
      if(ivar.eq.1)ul(i,j,l)=dummy3(i,nr-j+1,l)
      if(ivar.eq.2)vl(i,j,l)=dummy3(i,nr-j+1,l)
      if(ivar.eq.3)pdot(i,j,l)=dummy3(i,nr-j+1,l)
      if(ivar.eq.4)tl(i,j,l)=dummy3(i,nr-j+1,l)
      if(ivar.eq.5)ql(i,j,l)=dummy3(i,nr-j+1,l)
      if(ivar.eq.6)hgtl(i,j,l)=dummy3(i,nr-j+1,l)
      enddo
      enddo
      enddo
      enddo
c
c now swap longitudes
c
      do j=1,nr
      dummy1(j)=alat(j)
      enddo
      do j=1,nr
      alat(j)=dummy1(nr-j+1)
      enddo
c
c convert from relative humidity (%) to mixing ratio
c
       do i=1,nc
       do j=1,nr
       do k=1,nl
c
c
c AERK recommended approximation for vapor pressure of pure
c water vapor over plane surface of water (equation 21,
c Alduchov and EWskridge, J. App Met, 35 1996 pp 601-609)
c
        et=6.1094*exp(17.625*(tl(i,j,k)-273.16)/
     &                  (243.04+(tl(i,j,k)-273.16)))
c
c correction (equation 22) for moist air above plane surface
c of water
c
        et=1.00071*exp(0.0000045*eta(k))*et
        RMIX=0.622*et/(eta(k)-et)
        QSAT=RMIX/(1.0+RMIX)
        ql(i,j,k)=ql(i,j,k)*qsat/100.
       enddo
       enddo
       enddo

      return
      end



      subroutine swap_longs_2d(array,tempo,nc,nr)
c
c subroutine to shift longitudes from -180 -> 180
c to 0 -> 360                        tdf 8/15/2K5
      real array(nc,nr), tempo(nc,nr)
      nc2 = nc/2
      do j = 1, nr
         do i = 1, nc2
            tempo(i,j) = array(nc2+i,j)
            tempo(nc2+i,j) = array(i,j)
         enddo
         do i = 1, nc
            array(i,j) = tempo(i,j)
         enddo
      enddo
      return
      end
      subroutine swap_longs_3d(array,tempo,nc,nr,nl)
c
c subroutine to shift longitudes from -180 -> 180
c to 0 -> 360                        tdf 8/15/2K5
      real array(nc,nr,nl), tempo(nc,nr,nl)
      nc2 = nc/2
      do k = 1, nl
        do j = 1, nr
          do i = 1, nc2
            tempo(i,j,k) = array(nc2+i,j,k)
            tempo(nc2+i,j,k) = array(i,j,k)
          enddo
          do i = 1, nc
            array(i,j,k) = tempo(i,j,k)
          enddo
        enddo
      enddo
      return
      end

      subroutine get_msf(nlg,nlat,nlv,TL,GL,MSF)
c
c diagnose MSF from geopotential height 
      parameter (R=287., g=9.81, Cp=1004.)
c
      real*4 tl(nlg,nlat,nlv), 
     +       gl(nlg,nlat,nlv), msf(nlg,nlat,nlv)
c
c gl is the geopotential height on the dashed levels
ctdf
ctdf Note the levels are ordered top-down
ctdf
      DO k = nlv, 1, -1
c       print *,' level k = ',k
        DO j = 1, nlat
          DO I = 1, nlg
ctdf Montgomery stream function
            MSF(I,J,K) = Cp * TL(I,J,K) + g * GL(I,J,K)
          enddo
        enddo
      enddo
      print *,' gl(1,90,k),k=1,nlv ',(gl(1,90,k),k=1,nlv)
      print *,' msf(1,90,k),k=1,nlv ',(msf(1,90,k),k=1,nlv)
      call flush(6)
      return
      end

      subroutine geopotential(nlg,nlat,nlv,TL,tempGL,GL,MSF,
     +                        psfc,zsfc,pdash,delp)
c
c diagnose geopotential height from hydrostatic equation
      parameter (R=287., g=9.81, Cp=1004.)
c
      real*4 tl(nlg,nlat,nlv), tempgl(nlg,nlat,nlv),
     +       gl(nlg,nlat,nlv), msf(nlg,nlat,nlv)
c
      real*4 zsfc(nlg,nlat),      psfc(nlg,nlat)
      real*4 pdash(nlg,nlat,nlv), delp(nlg,nlat,nlv)
c
c tempgl is the geopotential height on the interfaces

ctdf
ctdf Note the levels are ordered top-down
ctdf Check dimensions of delp and pdash
ctdf
      DO k = nlv, 1, -1
c       print *,' level k = ',k
c       call flush(6)
        DO j = 1, nlat
          DO I = 1, nlg
ctdf Compute delta-p / p
            if (pdash(i,j,k) .le. 0.0) then
              print *,' error pdash = 0'
              print *,' i,j,k ',i,j,k
              stop 
            endif
            dlogs = delp(I,J,K) / pdash(I,J,K)
            delz  = R * TL(I,J,K)/g * dlogs
            if (K .eq. NLV) then 
              tempgl(I,J,K) = zsfc(I,J) + delz
              GL(I,J,K) = zsfc(I,J) + 0.5 * delz
            else
              tempgl(I,J,K) = tempgl(I,J,K+1) + delz
              GL(I,J,K)   = tempgl(I,J,K+1) + 0.5 * delz
            endif
ctdf Montgomery stream function
            MSF(I,J,K) = Cp * TL(I,J,K) + g * GL(I,J,K)
c            if (i .eq. 1 .and. j .eq. 1) then 
c             print *,'     dlogs',dlogs
c             print *,'      delz',delz
c             print *,' delp(1,1)',delp(i,j,k)
c             print *,' TL(1,1)',TL(i,j,k)
c             print *,' GL(1,1)',GL(i,j,k)
c             print *,' MSF(1,1)',MSF(i,j,k)
c           endif
            call flush(6)
          enddo
        enddo
      enddo
      print *,(tempgl(1,45,k),k=1,nlv)
      print *,' gl(1,45,k),k=1,nlv '
      print *,(gl(1,45,k),k=1,nlv)
      print *,' msf(1,45,k),k=1,nlv '
      print *,(msf(1,45,k),k=1,nlv)
      call flush(6)
      return
      end

