idir='/home/bpierce/CalNex/HMS/Amber_global/Files_1x1_DN/'
openr,1,'gfs_mult.fil'
nfiles=0
date=''
readf,1,nfiles
for nf=0,nfiles-1 do begin
readf,1,date
date='20'+date
  flnm=idir+'modis_Dv7_bb_co_fuel_'+date+'_1x1.ALL'
  print,flnm
  close,2
;  openr,2,flnm,/f77,/SWAP_IF_LITTLE_ENDIAN
  openr,2,flnm,/f77
  print,flnm
  nx=0
  ny=0
  readu,2,nx,ny
  xlon=fltarr(nx)
  ylat=fltarr(ny)
  readu,2,xlon,ylat
  co_bb_modis=fltarr(nx,ny)
  readu,2,co_bb_modis
  print,'co_bb_modis=',max(co_bb_modis),min(co_bb_modis)
  close,2
  flnm=idir+'fireheight_Dv7_'+date+'_1x1.dat'
  print,flnm
  close,2
;  openr,2,flnm,/f77,/SWAP_IF_LITTLE_ENDIAN
  openr,2,flnm,/f77
  print,flnm
  nx=0
  ny=0
  readu,2,nx,ny
  xlon=fltarr(nx)
  ylat=fltarr(ny)
  readu,2,xlon,ylat
  fireheight=fltarr(nx,ny)
  readu,2,fireheight
  print,'fireheight=',max(fireheight),min(fireheight)
  close,2

;
; read UW-Hybrid analysis data
;
mdir='/raqms_data1/INTEX/UW-Hybrid/Netcdf_data/NMHC_v1_INTEX-B_FORECAST/'
mdir='/usr60/Data/Model/UW-Hybrid/INTEX/Reanalysis_200701c/Netcdf/'
mdir='/raqms-arc3/data/CalNex/UW-Hybrid/Mission_1X1/Netcdf/'
;
yr=strmid(date,0,4)
yr2=strmid(date,2,2)
mn=strmid(date,4,2)
dy=strmid(date,6,2)
mfile=yr2+mn+dy+'/uwhyb_'+mn+'_'+dy+'_'+yr+'_12Z.chem.assim.nc'
nc_file_id=ncdf_open(mdir+mfile,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
;print,'number of dimensions ',glob_info.ndims
;print,'number of variables ',glob_info.nvars
;print,'number of attributes ',glob_info.ngatts

; get dimensions
;
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    print,'dimension ',idim,name,dim
    if name eq 'lat' then nlat=dim
    if name eq 'lon' then nlon=dim
    if name eq 'lev' then nlev=dim
    if name eq 'theta' then ntheta=dim
endfor
;print,nlat,nlon,nlev
alat=dblarr(nlat)
alon=dblarr(nlon)
alev=dblarr(nlev)
atheta=dblarr(ntheta)
ncdf_varget,nc_file_id,'lat',alat
ncdf_varget,nc_file_id,'lon',alon
ncdf_varget,nc_file_id,'lev',alev
ncdf_varget,nc_file_id,'theta',atheta
;
;
; get variables
;
ncdf_varget,nc_file_id,'zsfc',zsfc
ncdf_varget,nc_file_id,'geop',geop
ncdf_varget,nc_file_id,'pdash',pdash
ncdf_varget,nc_file_id,'pbl',pbl
ncdf_varget,nc_file_id,'ptrop',ptrop
;
; interpolate to 1x1 degree grid
;
dum0=fltarr(nx,nlat)
dum1=fltarr(nx,nlat)
dum2=fltarr(nx,nlat)
dum3=fltarr(nx,nlat,nlev)
dum4=fltarr(nx,nlat,nlev)
for j=0,nlat-1 do begin
dum0(*,j)=interpol(zsfc(*,j),alon,xlon)
dum1(*,j)=interpol(pbl(*,j),alon,xlon)
dum2(*,j)=interpol(ptrop(*,j),alon,xlon)
for l=0,nlev-1 do begin
dum3(*,j,l)=interpol(geop(*,j,l),alon,xlon)
dum4(*,j,l)=interpol(pdash(*,j,l),alon,xlon)
endfor
endfor
zsfc1x1=fltarr(nx,ny)
pbl1x1=fltarr(nx,ny)
ptrop1x1=fltarr(nx,ny)
geop1x1=fltarr(nx,ny,nlev)
pdash1x1=fltarr(nx,ny,nlev)
for i=0,nx-1 do begin
zsfc1x1(i,*)=interpol(dum0(i,*),alat,ylat)
pbl1x1(i,*)=interpol(dum1(i,*),alat,ylat)
ptrop1x1(i,*)=interpol(dum2(i,*),alat,ylat)
for l=0,nlev-1 do begin
geop1x1(i,*,l)=interpol(dum3(i,*,l),alat,ylat)
pdash1x1(i,*,l)=interpol(dum4(i,*,l),alat,ylat)
endfor
endfor
pbl=zsfc1x1+pbl1x1
geop=geop1x1
pdash=pdash1x1
ptrop=ptrop1x1
alev_fire=alev(nlev-1)+0.*fltarr(nx,ny)
fire_depth=fltarr(nx,ny)
minlev=35l
firecount=0l
for i=0,nx-1 do begin
for j=0,ny-1 do begin
if co_bb_modis(i,j) gt 0. then begin
zfire=pbl(i,j)+1000.*fireheight(i,j)
fire_depth(i,j)=zfire-zsfc1x1(i,j)
dummy0=reform(geop(i,j,*),nlev)
dummy1=reform(pdash(i,j,*),nlev)
; fire height
index0=where(dummy0 le zfire)
index1=where(dummy1 ge ptrop(i,j))
; limit to tropopause
index=index0
lfire=index0(0)
ltrop=index1(0)
if ltrop gt lfire then begin
print,xlon(i),ylat(j),pdash(i,j,lfire),ptrop(i,j),' Tropopause limited fire depth'
index=index1
lfire=ltrop
endif
alev_fire(i,j)=pdash(i,j,lfire)
if lfire lt minlev then minlev=lfire
firecount=firecount+25l*n_elements(index)
endif
endfor
endfor
print,'number of fire trajectories=',firecount
print,'maximum fire depth=',35l-minlev,' model levels'
;
; write out ascii fire initialization file
;
close,3,4
openw,3,'wild_fire_trajectories_'+date+'.dat'
openw,4,'wild_fire_trajectories.dat'
printf,3,firecount
printf,4,firecount
;
; initialize wildfire trajectories at higher resolution
; then the emission data set 
;
for i=0,nx-1 do begin
for j=0,ny-1 do begin
if co_bb_modis(i,j) gt 0. then begin
for l=nlev-1,0,-1 do begin
if alev_fire(i,j) le pdash(i,j,l) then begin
dx=-0.5
for incx=0,4 do begin
dy=-0.5
for incy=0,4 do begin
printf,3,xlon(i)+dx,ylat(j)+dy,pdash(i,j,l),co_bb_modis(i,j),fire_depth(i,j)
printf,4,xlon(i)+dx,ylat(j)+dy,pdash(i,j,l),co_bb_modis(i,j),fire_depth(i,j)
dy=dy+0.2
endfor
dx=dx+0.2
endfor
endif
endfor
endif
endfor
endfor
close,3,4
endfor
end
